Subject: Re: Problem with Linus's git repository?

From: Andreas Ericsson <[email-masked]>
Date: Fri, 29 Jun 2007 15:00:09 +0200

walt wrote:
> 
> On Thu, 28 Jun 2007, Linus Torvalds wrote:
> 
>> On Thu, 28 Jun 2007, walt wrote:
>>> No, every morning I pull from you and Junio and Petr Baudis using cg-update,
> 
> 
>> Oh, don't use "cg-update", or just fix it to do "git pull".
> 
> I'm happy to stick with using git.  From reading the latest Docs, it seems
> that git-pull -v will do what I need (I think).
> 
> That's what I did just now to update from you and Junio, and the output
> seemed exactly appropriate -- ended with a fast-forward and no errors
> for either one.
> 
> However, a git-fsck turned up four dangling commits for Junio, and 42
> danglers for you, including a mix of blobs, trees, and commits.
> 

You will see dangling commits, blobs and trees from Junio because he rewinds
his 'pu' branch.

I'm not sure why you see any from Linus, as I'm not aware of any rewinding
in the official kernel tree (unless you're talking about some other repo,
in which case I'm clueless).

> Will a simple git-prune bring me correctly up to date, or am I missing
> some steps?
> 

You're already up to date. The dangling commits do not hurt your repo
in any way. Nor do they hurt the performance of any of the tools you
normally use. fsck suffers a bit from them, because it has to care
about them, but the normal DAG-traversing tools will never even
see them.

git prune would remove them and save you a tiny bit of diskspace.
Next time you pull from Junio, you'll most likely get orphaned commits
again though, meaning blobs, trees and commits will end up dangling once
more. It's perfectly normal and nothing to worry about.

For repo maintenance, I run "git gc" once a month on my local copies.
More to let my laptop do something while I'm fiddling with receipts and
stuff than for any real need (the idea of idle computers offend me for
some reason).

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231